#include <iostream>
#include <fstream>
#include <cstdio>
#include <vector>

using namespace std;

typedef long long lint;

vector <vector<int> > edge(200000);
pair <int, int> maxims[200000];

void ldfs(int v) {
	int siz = edge[v].size();
	if (siz == 0)
	{
		maxims[v].first = 0;
		maxims[v].second = 0;
//		cout << v << " " << maxims[v].first << " " << maxims[v].second << endl;
		return;
	}
	if (siz == 1) {
		ldfs(edge[v][0]);
		maxims[v].first = maxims[edge[v][0]].first + 1;
		maxims[v].second = 0;
//		cout << v << " " << maxims[v].first << " " << maxims[v].second << endl;
		return;
	}
	int max = -1;
	int secmax = -1;
	for (int i = 0; i < siz; i++) {
		ldfs(edge[v][i]);
		int value = maxims[edge[v][i]].first;
		if (value > max) {
			max = value;
		}
		else {
			if (value > secmax) {
				secmax = value;
			}
		}
	}
	maxims[v].first = max + 1;
	maxims[v].second = secmax + 1;
//	cout << v << " " << maxims[v].first << " " << maxims[v].second << endl;
	return;
}

int hdfs(int v) {
	int siz = edge[v].size();
	int max = -1;
	for (int i = 0; i < siz; i++) {
		int cur = hdfs(edge[v][i]);
		if (cur > max) {
			max = cur;
		}
	}
	return max + 1;
}

int main() {
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	lint m, n;
	cin >> n >> m;
	for (int i = 1; i < n; i++) {
		int v;
		scanf("%d", &v);
		v--;
		edge[v].push_back(i);
	}
	int maxheight = hdfs(0);
	int maxline = 0;
	ldfs(0);
	for (int i = 0; i < n; i++) {
		if (maxims[i].first + maxims[i].second > maxline) {
			maxline = maxims[i].first + maxims[i].second;
		}
	}
//	cout << maxline << " " << maxheight << endl;
	cout << maxline + (m - 1) * (maxheight + 1) * 2 + 1 << endl;
}