#include <iostream>
#include <fstream>
#include <cstdio>
#include <vector>

using namespace std;

typedef long long lint;

vector <vector<int> > edge(200000);
pair <lint, lint> maxims[200000];
lint maxheights[200000];
lint m, n;
lint height;

void ldfs(int v) {
	int siz = edge[v].size();
	if (siz == 0)
	{
		maxims[v].first = (m - 1) * height;
		maxims[v].second = 0;
//		cout << v << " " << maxims[v].first << " " << maxims[v].second << endl;
		return;
	}
	if (siz == 1) {
		maxims[v].first = maxims[edge[v][0]].first + 1;
		maxims[v].second = 0;
//		cout << v << " " << maxims[v].first << " " << maxims[v].second << endl;
		return;
	}
	lint max = -1;
	lint secmax = -1;
	lint max0 = -1;
	for (int i = 0; i < siz; i++) {
		lint value = maxims[edge[v][i]].first;
		if (value > max) {
			max = value;
			max0 = i;
		}
	}
	for (int i = 0; i < siz; i++) {
		lint value = maxims[edge[v][i]].first;
		if ((value > secmax) && (i != max0)){
			secmax = value;
		}
	}
	
	maxims[v].first = max + 1;
	maxims[v].second = secmax + 1;
//	cout << v << " " << maxims[v].first << " " << maxims[v].second << endl;
	return;
}

void hdfs(int v) {
	int siz = edge[v].size();
	lint max = -1;
	for (int i = 0; i < siz; i++) {
		lint cur = maxheights[edge[v][i]];
		if (cur > max) {
			max = cur;
		}
	}
	maxheights[v] = max + 1;
	return;
}

int main() {
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	cin >> n >> m;
	for (int i = 1; i < n; i++) {
		int v;
		scanf("%d", &v);
		v--;
		edge[v].push_back(i);
	}
	for (int i = n - 1; i >= 0; i--) {
		hdfs(i);
//		cout << maxheights[i] << endl;
	}
	height = maxheights[0] + 1;
//	cout << height << endl;
	lint maxline = 0;
	for (int i = n - 1; i >= 0; i--) {
		ldfs(i);
	}
	for (int i = 0; i < n; i++) {
		if (maxims[i].first + maxims[i].second > maxline) {
			maxline = maxims[i].first + maxims[i].second;
		}
	}
	cout << ++maxline << endl;
}